#version 410

/* Viewport width and height */
uniform ivec2 viewport_size;
/* Position of lower left corner of rectangle */
uniform ivec2 position;
/* Size of the rectangle */
uniform ivec2 size;

/* Vertex coordinates: x, y (0 or 1) */
layout(location = 0) in ivec2 coords;

/**
 * Map coordinates such that:
 * (0 .. viewport_size.[xy]) => (-1.0 .. 1.0)
 */
vec2 map_to_screen(vec2 position)
{
    return 2.0 * position / viewport_size - 1.0;
}

void main(void)
{
    gl_Position = vec4(map_to_screen(vec2(position + coords * size)), 0, 1);
}
